"use strict";
process.on('unhandledRejection', up => { throw up; });
const fs = require('fs-extra');
const path = require('path');
const FINAL_DIR = path.join(BASE_DIR, '../../dist');
const BASE_DIR = path.join(__dirname, '..');
// 生成数据源管理中数据源内置方法的示例代码
function generateSampleCode() {
    const srcPath = path.join(BASE_DIR, 'dist/builtin-method/database.js');
    const content = fs.readFileSync(srcPath, 'utf8');
    const codeStart = (() => {
        let idx = content.indexOf('dbDefaultMethods');
        return content.indexOf('{', idx) + 1;
    })();
    const codeEnd = (() => {
        let idx = content.lastIndexOf('dbDefaultMethods');
        return content.lastIndexOf('}', idx) - 1;
    })();
    const code = content
        .slice(codeStart, codeEnd)
        .split('\n')
        .map(s => s.replace(/^\s{4}/, ''))
        .join('\n');
    const fnCodes = code
        .split(/\b(?=async)/)
        .filter(c => !!c.trim())
        .reduce((acc, c) => {
        let key = '';
        const val = c.trim().replace(/,$/, '')
            .replace(/^async\s*([a-zA-Z]+)/, ($0, $1) => {
            key = $1;
            return `module.exports = async function `;
        })
            .split('\n')
            .map(l => l.replace(/\/\/\s*\@ts-ignore.*$/, ''))
            .join('\n');
        acc[key] = val;
        return acc;
    }, {});
    fs.ensureDirSync(FINAL_DIR);
    fs.writeFileSync(path.join(FINAL_DIR, 'code-sample.js'), 'export const codes = ' + JSON.stringify(fnCodes, null, 2), 'utf8');
}
async function main() {
    await generateSampleCode();
}
main();
